"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const os_1 = require("os");
const helpers_1 = require("../../common/helpers");
class AnalyticsLoggingService {
    constructor($fs, logFile) {
        this.$fs = $fs;
        this.logFile = logFile;
    }
    logData(analyticsLoggingMessage) {
        if (this.logFile && analyticsLoggingMessage && analyticsLoggingMessage.message) {
            analyticsLoggingMessage.type = analyticsLoggingMessage.type || "Info";
            const formattedDate = helpers_1.getFixedLengthDateString();
            this.$fs.appendFile(this.logFile, `[${formattedDate}] [${analyticsLoggingMessage.type}] ${analyticsLoggingMessage.message}${os_1.EOL}`);
        }
    }
}
exports.AnalyticsLoggingService = AnalyticsLoggingService;
